using System.Collections.Generic;
using System.Threading.Tasks;
using Autofac;
using FitConnect.Models;
using FitConnect.Services.Interfaces;
using Moq;

namespace BasicUnitTest.Mocking;

public static class MockDependencyContainer {
    public static IContainer Container => _container ??= Create();

    private static IContainer? _container;

    private static Submission CreateSubmission() {
        var result = new Submission();

        var data = @"{""name"":""John Doe""}";
        var attachments = new List<Attachment>();
        
        return result;
    }

    private static IContainer Create() {
        var builder = new ContainerBuilder();
        var submissionService = new Mock<ISubmissionService>();
        submissionService.Setup(
            s => s.GetSubmissionAsync(It.IsAny<string>())).Returns(
            () => Task.FromResult(CreateSubmission())
        );
        return builder.Build();
    }
}
